{
    "$graph": [
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/bam_readgroup_to_json:7cb045ba57c027e283fbf42ea566f39b5f4846b1381e69b9e36e32bb978f0c9a"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 1000,
                    "ramMax": 1000,
                    "tmpdirMin": 1,
                    "tmpdirMax": 1,
                    "outdirMin": 1,
                    "outdirMax": 1
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/INPUT",
                    "type": "File",
                    "format": "#bam_readgroup_to_json.cwl/format_2572",
                    "inputBinding": {
                        "prefix": "--bam_path"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/MODE",
                    "type": "string",
                    "default": "strict",
                    "inputBinding": {
                        "prefix": "--mode"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bam_readgroup_to_json"
            ],
            "id": "#bam_readgroup_to_json.cwl",
            "outputs": [
                {
                    "id": "#bam_readgroup_to_json.cwl/OUTPUT",
                    "format": "#bam_readgroup_to_json.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*.json",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#bam_readgroup_to_json.cwl/log",
                    "type": "File",
                    "outputBinding": {
                        "glob": "output.log"
                    }
                }
            ]
        },
        {
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "quay.io/ncigdc/biobambam:533ed9be5fd34b177b5a906262c615bff1a4cdc2c84b78c2244cbd7283842120"
                },
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "ResourceRequirement",
                    "coresMin": 1,
                    "coresMax": 1,
                    "ramMin": 2000,
                    "ramMax": 2000,
                    "tmpdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "tmpdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMin": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))",
                    "outdirMax": "$(Math.ceil(0.9 * inputs.filename.size / 1048576))"
                }
            ],
            "class": "CommandLineTool",
            "inputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/collate",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "collate=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/exclude",
                    "type": "string",
                    "default": "QCFAIL,SECONDARY,SUPPLEMENTARY",
                    "inputBinding": {
                        "prefix": "exclude=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/filename",
                    "format": "#biobambam2_bamtofastq.cwl/format_2572",
                    "type": "File",
                    "inputBinding": {
                        "prefix": "filename=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/gz",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "gz=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/inputformat",
                    "type": "string",
                    "default": "bam",
                    "inputBinding": {
                        "prefix": "inputformat=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/level",
                    "type": "int",
                    "default": 5,
                    "inputBinding": {
                        "prefix": "level=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputdir",
                    "type": "string",
                    "default": ".",
                    "inputBinding": {
                        "prefix": "outputdir=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroup",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "outputperreadgroup=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF",
                    "type": "string",
                    "default": "_1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixF2",
                    "type": "string",
                    "default": "_2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixF2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO",
                    "type": "string",
                    "default": "_o1.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixO2",
                    "type": "string",
                    "default": "_o2.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixO2=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/outputperreadgroupsuffixS",
                    "type": "string",
                    "default": "_s.fq.gz",
                    "inputBinding": {
                        "prefix": "outputperreadgroupsuffixS=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/tryoq",
                    "type": "int",
                    "default": 1,
                    "inputBinding": {
                        "prefix": "tryoq=",
                        "separate": false
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/T",
                    "type": "string",
                    "default": "tempfq",
                    "inputBinding": {
                        "prefix": "T=",
                        "separate": false
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o1",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o1.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_o2",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_o2.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                },
                {
                    "id": "#biobambam2_bamtofastq.cwl/output_fastq_s",
                    "format": "#biobambam2_bamtofastq.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    },
                    "outputBinding": {
                        "glob": "*_s.fq.gz",
                        "outputEval": "${ return self.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) }) }\n"
                    }
                }
            ],
            "baseCommand": [
                "/usr/local/bin/bamtofastq"
            ],
            "id": "#biobambam2_bamtofastq.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#decider_readgroup_expression.cwl/fastq",
                    "format": "#decider_readgroup_expression.cwl/format_2182",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                },
                {
                    "id": "#decider_readgroup_expression.cwl/readgroup_json",
                    "format": "#decider_readgroup_expression.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#decider_readgroup_expression.cwl/output",
                    "format": "#decider_readgroup_expression.cwl/format_3464",
                    "type": {
                        "type": "array",
                        "items": "File"
                    }
                }
            ],
            "expression": "${\n   function include(arr,obj) {\n     return (arr.indexOf(obj) != -1)\n   }\n\n   function endsWith(str, suffix) {\n     return str.indexOf(suffix, str.length - suffix.length) !== -1;\n   }\n\n   function local_basename(path) {\n     var basename = path.split(/[\\\\/]/).pop();\n     return basename\n   }\n\n   function local_dirname(path) {\n     return path.replace(/\\\\/g,'/').replace(/\\/[^\\/]*$/, '');\n   }\n\n   function get_slice_number(fastq_name) {\n     if (endsWith(fastq_name, '_1.fq.gz')) {\n       return -8\n     }\n     else if (endsWith(fastq_name, '_s.fq.gz')) {\n       return -8\n     }\n     else if (endsWith(fastq_name, '_o1.fq.gz')) {\n       return -9\n     }\n     else if (endsWith(fastq_name, '_o2.fq.gz')) {\n       return -9\n     }\n     else {\n       throw \"not recognized fastq suffix\"\n     }\n   }\n   \n   // get predicted readgroup basenames from fastq\n   var readgroup_basename_array = [];\n   for (var i = 0; i < inputs.fastq.length; i++) {\n     var fq_path = inputs.fastq[i];\n     var fq_name = local_basename(fq_path.location);\n\n     var slice_number = get_slice_number(fq_name);\n     \n     var readgroup_name = fq_name.slice(0,slice_number) + \".json\";\n     readgroup_basename_array.push(readgroup_name);\n   }\n\n   // find which readgroup items are in predicted basenames\n   var readgroup_array = [];\n   for (var i = 0; i < inputs.readgroup_json.length; i++) {\n     var readgroup = inputs.readgroup_json[i];\n     var readgroup_basename = local_basename(readgroup.location);\n     if (include(readgroup_basename_array, readgroup_basename)) {\n       readgroup_array.push(readgroup);\n     }\n   }\n\n   var readgroup_sorted = readgroup_array.sort(function(a,b) { return a.location > b.location ? 1 : (a.location < b.location ? -1 : 0) });\n   return {'output': readgroup_sorted}\n }\n",
            "id": "#decider_readgroup_expression.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "name": "#readgroup.yml/readgroup_meta",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_meta/CN",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/DT",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/FO",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/ID",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/KS",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/LB",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PI",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PL",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PM",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/PU",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/SM",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/flow_cell_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/lane_number",
                                    "type": [
                                        "null",
                                        "long"
                                    ]
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_meta/multiplex_barcode",
                                    "type": [
                                        "null",
                                        "string"
                                    ]
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/forward_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/reverse_fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/fastq",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_file/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_file",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/bam",
                                    "type": "File"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_file/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_pe_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/forward_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/reverse_fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_pe_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroup_fastq_se_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/fastq_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroup_fastq_se_uuid/readgroup_meta",
                                    "type": "#readgroup.yml/readgroup_meta"
                                }
                            ]
                        },
                        {
                            "name": "#readgroup.yml/readgroups_bam_uuid",
                            "type": "record",
                            "fields": [
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_uuid",
                                    "type": "string"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/bam_file_size",
                                    "type": "long"
                                },
                                {
                                    "name": "#readgroup.yml/readgroups_bam_uuid/readgroup_meta_list",
                                    "type": {
                                        "type": "array",
                                        "items": "#readgroup.yml/readgroup_meta"
                                    }
                                }
                            ]
                        }
                    ]
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_json_readgroup_meta.cwl/input",
                    "type": "File",
                    "inputBinding": {
                        "loadContents": true,
                        "valueFrom": "$(null)"
                    }
                }
            ],
            "outputs": [
                {
                    "id": "#emit_json_readgroup_meta.cwl/output",
                    "type": "#readgroup.yml/readgroup_meta"
                }
            ],
            "expression": "${\n  var readgroup = JSON.parse(inputs.input.contents);\n  var output = new Object();\n  for (var i in readgroup) {\n    if (i.length == 2) {\n      if (i == 'PL') {\n        output[i] = readgroup[i].toUpperCase();\n      } else {\n        output[i] = readgroup[i];\n      }\n    }\n  }\n\n  return {'output': output};\n}\n",
            "id": "#emit_json_readgroup_meta.cwl"
        },
        {
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "InlineJavascriptRequirement"
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/forward_fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/reverse_fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/readgroup_meta",
                    "type": "#readgroup.yml/readgroup_meta"
                }
            ],
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_pe_file.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_pe_file"
                }
            ],
            "expression": "${\n  var output = { \"forward_fastq\": inputs.forward_fastq,\n                 \"reverse_fastq\": inputs.reverse_fastq,\n                 \"readgroup_meta\": inputs.readgroup_meta\n                 };\n  output.forward_fastq.format = \"edam:format_2182\";\n  output.reverse_fastq.format = \"edam:format_2182\";\n  return {'output': output}\n}\n",
            "id": "#emit_readgroup_fastq_pe_file.cwl"
        },
        {
            "requirements": [
                {
                    "class": "InlineJavascriptRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                }
            ],
            "class": "ExpressionTool",
            "inputs": [
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/fastq",
                    "type": "File"
                },
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/readgroup_meta",
                    "type": "#readgroup.yml/readgroup_meta"
                }
            ],
            "outputs": [
                {
                    "id": "#emit_readgroup_fastq_se_file.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_se_file"
                }
            ],
            "expression": "${\n  var output = { \"fastq\": inputs.fastq,\n                 \"readgroup_meta\": inputs.readgroup_meta};\n  output.fastq.format = \"edam:format_2182\";\n  return {'output': output}\n}\n",
            "id": "#emit_readgroup_fastq_se_file.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#readgroup_fastq_pe.cwl/forward_fastq",
                    "type": "File"
                },
                {
                    "id": "#readgroup_fastq_pe.cwl/reverse_fastq",
                    "type": "File"
                },
                {
                    "id": "#readgroup_fastq_pe.cwl/readgroup_json",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#readgroup_fastq_pe.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_pe_file",
                    "outputSource": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe/output"
                }
            ],
            "steps": [
                {
                    "id": "#readgroup_fastq_pe.cwl/emit_json_readgroup_meta",
                    "run": "#emit_json_readgroup_meta.cwl",
                    "in": [
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_json_readgroup_meta/input",
                            "source": "#readgroup_fastq_pe.cwl/readgroup_json"
                        }
                    ],
                    "out": [
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_json_readgroup_meta/output"
                        }
                    ]
                },
                {
                    "id": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe",
                    "run": "#emit_readgroup_fastq_pe_file.cwl",
                    "in": [
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe/forward_fastq",
                            "source": "#readgroup_fastq_pe.cwl/forward_fastq"
                        },
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe/reverse_fastq",
                            "source": "#readgroup_fastq_pe.cwl/reverse_fastq"
                        },
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe/readgroup_meta",
                            "source": "#readgroup_fastq_pe.cwl/emit_json_readgroup_meta/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#readgroup_fastq_pe.cwl/emit_readgroup_fastq_pe/output"
                        }
                    ]
                }
            ],
            "id": "#readgroup_fastq_pe.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                }
            ],
            "inputs": [
                {
                    "id": "#readgroup_fastq_se.cwl/fastq",
                    "type": "File"
                },
                {
                    "id": "#readgroup_fastq_se.cwl/readgroup_json",
                    "type": "File"
                }
            ],
            "outputs": [
                {
                    "id": "#readgroup_fastq_se.cwl/output",
                    "type": "#readgroup.yml/readgroup_fastq_se_file",
                    "outputSource": "#readgroup_fastq_se.cwl/emit_readgroup_fastq_se/output"
                }
            ],
            "steps": [
                {
                    "id": "#readgroup_fastq_se.cwl/emit_json_readgroup_meta",
                    "run": "#emit_json_readgroup_meta.cwl",
                    "in": [
                        {
                            "id": "#readgroup_fastq_se.cwl/emit_json_readgroup_meta/input",
                            "source": "#readgroup_fastq_se.cwl/readgroup_json"
                        }
                    ],
                    "out": [
                        {
                            "id": "#readgroup_fastq_se.cwl/emit_json_readgroup_meta/output"
                        }
                    ]
                },
                {
                    "id": "#readgroup_fastq_se.cwl/emit_readgroup_fastq_se",
                    "run": "#emit_readgroup_fastq_se_file.cwl",
                    "in": [
                        {
                            "id": "#readgroup_fastq_se.cwl/emit_readgroup_fastq_se/fastq",
                            "source": "#readgroup_fastq_se.cwl/fastq"
                        },
                        {
                            "id": "#readgroup_fastq_se.cwl/emit_readgroup_fastq_se/readgroup_meta",
                            "source": "#readgroup_fastq_se.cwl/emit_json_readgroup_meta/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#readgroup_fastq_se.cwl/emit_readgroup_fastq_se/output"
                        }
                    ]
                }
            ],
            "id": "#readgroup_fastq_se.cwl"
        },
        {
            "class": "Workflow",
            "requirements": [
                {
                    "class": "ScatterFeatureRequirement"
                },
                {
                    "class": "SchemaDefRequirement",
                    "types": [
                        {
                            "$import": "#readgroup.yml/readgroup_meta"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_file"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_pe_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroup_fastq_se_uuid"
                        },
                        {
                            "$import": "#readgroup.yml/readgroups_bam_uuid"
                        }
                    ]
                },
                {
                    "class": "StepInputExpressionRequirement"
                },
                {
                    "class": "SubworkflowFeatureRequirement"
                }
            ],
            "inputs": [
                {
                    "id": "#main/readgroups_bam_file",
                    "type": "#readgroup.yml/readgroups_bam_file"
                }
            ],
            "outputs": [
                {
                    "id": "#main/pe_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_pe_file"
                    },
                    "outputSource": "#main/readgroup_fastq_pe/output"
                },
                {
                    "id": "#main/se_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/readgroup_fastq_se/output"
                },
                {
                    "id": "#main/o1_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/readgroup_fastq_o1/output"
                },
                {
                    "id": "#main/o2_file_list",
                    "type": {
                        "type": "array",
                        "items": "#readgroup.yml/readgroup_fastq_se_file"
                    },
                    "outputSource": "#main/readgroup_fastq_o2/output"
                }
            ],
            "steps": [
                {
                    "id": "#main/biobambam_bamtofastq",
                    "run": "#biobambam2_bamtofastq.cwl",
                    "in": [
                        {
                            "id": "#main/biobambam_bamtofastq/filename",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.bam)"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/biobambam_bamtofastq/output_fastq_s"
                        }
                    ]
                },
                {
                    "id": "#main/bam_readgroup_to_json",
                    "run": "#bam_readgroup_to_json.cwl",
                    "in": [
                        {
                            "id": "#main/bam_readgroup_to_json/INPUT",
                            "source": "#main/readgroups_bam_file",
                            "valueFrom": "$(self.bam)"
                        },
                        {
                            "id": "#main/bam_readgroup_to_json/MODE",
                            "valueFrom": "lenient"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ]
                },
                {
                    "id": "#main/decider_readgroup_pe",
                    "run": "#decider_readgroup_expression.cwl",
                    "in": [
                        {
                            "id": "#main/decider_readgroup_pe/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/decider_readgroup_pe/readgroup_json",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/decider_readgroup_pe/output"
                        }
                    ]
                },
                {
                    "id": "#main/decider_readgroup_se",
                    "run": "#decider_readgroup_expression.cwl",
                    "in": [
                        {
                            "id": "#main/decider_readgroup_se/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_s"
                        },
                        {
                            "id": "#main/decider_readgroup_se/readgroup_json",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/decider_readgroup_se/output"
                        }
                    ]
                },
                {
                    "id": "#main/decider_readgroup_o1",
                    "run": "#decider_readgroup_expression.cwl",
                    "in": [
                        {
                            "id": "#main/decider_readgroup_o1/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/decider_readgroup_o1/readgroup_json",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/decider_readgroup_o1/output"
                        }
                    ]
                },
                {
                    "id": "#main/decider_readgroup_o2",
                    "run": "#decider_readgroup_expression.cwl",
                    "in": [
                        {
                            "id": "#main/decider_readgroup_o2/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/decider_readgroup_o2/readgroup_json",
                            "source": "#main/bam_readgroup_to_json/OUTPUT"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/decider_readgroup_o2/output"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_fastq_pe",
                    "run": "#readgroup_fastq_pe.cwl",
                    "scatter": [
                        "#main/readgroup_fastq_pe/forward_fastq",
                        "#main/readgroup_fastq_pe/reverse_fastq",
                        "#main/readgroup_fastq_pe/readgroup_json"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#main/readgroup_fastq_pe/forward_fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq1"
                        },
                        {
                            "id": "#main/readgroup_fastq_pe/reverse_fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq2"
                        },
                        {
                            "id": "#main/readgroup_fastq_pe/readgroup_json",
                            "source": "#main/decider_readgroup_pe/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_fastq_pe/output"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_fastq_se",
                    "run": "#readgroup_fastq_se.cwl",
                    "scatter": [
                        "#main/readgroup_fastq_se/fastq",
                        "#main/readgroup_fastq_se/readgroup_json"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#main/readgroup_fastq_se/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_s"
                        },
                        {
                            "id": "#main/readgroup_fastq_se/readgroup_json",
                            "source": "#main/decider_readgroup_se/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_fastq_se/output"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_fastq_o1",
                    "run": "#readgroup_fastq_se.cwl",
                    "scatter": [
                        "#main/readgroup_fastq_o1/fastq",
                        "#main/readgroup_fastq_o1/readgroup_json"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#main/readgroup_fastq_o1/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o1"
                        },
                        {
                            "id": "#main/readgroup_fastq_o1/readgroup_json",
                            "source": "#main/decider_readgroup_o1/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_fastq_o1/output"
                        }
                    ]
                },
                {
                    "id": "#main/readgroup_fastq_o2",
                    "run": "#readgroup_fastq_se.cwl",
                    "scatter": [
                        "#main/readgroup_fastq_o2/fastq",
                        "#main/readgroup_fastq_o2/readgroup_json"
                    ],
                    "scatterMethod": "dotproduct",
                    "in": [
                        {
                            "id": "#main/readgroup_fastq_o2/fastq",
                            "source": "#main/biobambam_bamtofastq/output_fastq_o2"
                        },
                        {
                            "id": "#main/readgroup_fastq_o2/readgroup_json",
                            "source": "#main/decider_readgroup_o2/output"
                        }
                    ],
                    "out": [
                        {
                            "id": "#main/readgroup_fastq_o2/output"
                        }
                    ]
                }
            ],
            "id": "#main"
        }
    ],
    "cwlVersion": "v1.0"
}
